package cn.ibizlab.businesscentral.core.odoo_account.service.impl;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import java.util.Set;
import java.util.Map;
import java.util.HashSet;
import java.util.HashMap;
import java.util.Collection;
import java.util.Objects;
import java.util.Optional;
import java.math.BigInteger;

import lombok.extern.slf4j.Slf4j;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.stereotype.Service;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.util.ObjectUtils;
import org.springframework.beans.factory.annotation.Value;
import cn.ibizlab.businesscentral.util.errors.BadRequestAlertException;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.context.annotation.Lazy;
import cn.ibizlab.businesscentral.core.odoo_account.domain.Account_common_journal_report;
import cn.ibizlab.businesscentral.core.odoo_account.filter.Account_common_journal_reportSearchContext;
import cn.ibizlab.businesscentral.core.odoo_account.service.IAccount_common_journal_reportService;

import cn.ibizlab.businesscentral.util.helper.CachedBeanCopier;
import cn.ibizlab.businesscentral.util.helper.DEFieldCacheMap;


import cn.ibizlab.businesscentral.core.odoo_account.client.account_common_journal_reportFeignClient;

/**
 * 实体[通用日记账报告] 服务对象接口实现
 */
@Slf4j
@Service
public class Account_common_journal_reportServiceImpl implements IAccount_common_journal_reportService {

    @Autowired
    account_common_journal_reportFeignClient account_common_journal_reportFeignClient;


    @Override
    public boolean create(Account_common_journal_report et) {
        Account_common_journal_report rt = account_common_journal_reportFeignClient.create(et);
        if(rt==null)
            return false;
        CachedBeanCopier.copy(rt,et);
        return true;
    }

    public void createBatch(List<Account_common_journal_report> list){
        account_common_journal_reportFeignClient.createBatch(list) ;
    }

    @Override
    public boolean update(Account_common_journal_report et) {
        Account_common_journal_report rt = account_common_journal_reportFeignClient.update(et.getId(),et);
        if(rt==null)
            return false;
        CachedBeanCopier.copy(rt,et);
        return true;

    }

    public void updateBatch(List<Account_common_journal_report> list){
        account_common_journal_reportFeignClient.updateBatch(list) ;
    }

    @Override
    public boolean remove(Long id) {
        boolean result=account_common_journal_reportFeignClient.remove(id) ;
        return result;
    }

    public void removeBatch(Collection<Long> idList){
        account_common_journal_reportFeignClient.removeBatch(idList);
    }

    @Override
    public Account_common_journal_report get(Long id) {
		Account_common_journal_report et=account_common_journal_reportFeignClient.get(id);
        if(et==null){
            et=new Account_common_journal_report();
            et.setId(id);
        }
        else{
        }
        return  et;
    }





    /**
     * 查询集合 默认查询
     */
    @Override
    public Page<Account_common_journal_report> searchDefault(Account_common_journal_reportSearchContext context) {
        Page<Account_common_journal_report> account_common_journal_reports=account_common_journal_reportFeignClient.search(context);
        return account_common_journal_reports;
    }



}



