package cn.ibizlab.businesscentral.core.odoo_base.service.impl;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import java.util.Set;
import java.util.Map;
import java.util.HashSet;
import java.util.HashMap;
import java.util.Collection;
import java.util.Objects;
import java.util.Optional;
import java.math.BigInteger;

import lombok.extern.slf4j.Slf4j;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.stereotype.Service;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.util.ObjectUtils;
import org.springframework.beans.factory.annotation.Value;
import cn.ibizlab.businesscentral.util.errors.BadRequestAlertException;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.context.annotation.Lazy;
import cn.ibizlab.businesscentral.core.odoo_base.domain.Base_automation_line_test;
import cn.ibizlab.businesscentral.core.odoo_base.filter.Base_automation_line_testSearchContext;
import cn.ibizlab.businesscentral.core.odoo_base.service.IBase_automation_line_testService;

import cn.ibizlab.businesscentral.util.helper.CachedBeanCopier;
import cn.ibizlab.businesscentral.util.helper.DEFieldCacheMap;


import cn.ibizlab.businesscentral.core.odoo_base.client.base_automation_line_testFeignClient;

/**
 * 实体[自动化规则行测试] 服务对象接口实现
 */
@Slf4j
@Service
public class Base_automation_line_testServiceImpl implements IBase_automation_line_testService {

    @Autowired
    base_automation_line_testFeignClient base_automation_line_testFeignClient;


    @Override
    public boolean create(Base_automation_line_test et) {
        Base_automation_line_test rt = base_automation_line_testFeignClient.create(et);
        if(rt==null)
            return false;
        CachedBeanCopier.copy(rt,et);
        return true;
    }

    public void createBatch(List<Base_automation_line_test> list){
        base_automation_line_testFeignClient.createBatch(list) ;
    }

    @Override
    public boolean update(Base_automation_line_test et) {
        Base_automation_line_test rt = base_automation_line_testFeignClient.update(et.getId(),et);
        if(rt==null)
            return false;
        CachedBeanCopier.copy(rt,et);
        return true;

    }

    public void updateBatch(List<Base_automation_line_test> list){
        base_automation_line_testFeignClient.updateBatch(list) ;
    }

    @Override
    public boolean remove(Long id) {
        boolean result=base_automation_line_testFeignClient.remove(id) ;
        return result;
    }

    public void removeBatch(Collection<Long> idList){
        base_automation_line_testFeignClient.removeBatch(idList);
    }

    @Override
    public Base_automation_line_test get(Long id) {
		Base_automation_line_test et=base_automation_line_testFeignClient.get(id);
        if(et==null){
            et=new Base_automation_line_test();
            et.setId(id);
        }
        else{
        }
        return  et;
    }





    /**
     * 查询集合 默认查询
     */
    @Override
    public Page<Base_automation_line_test> searchDefault(Base_automation_line_testSearchContext context) {
        Page<Base_automation_line_test> base_automation_line_tests=base_automation_line_testFeignClient.search(context);
        return base_automation_line_tests;
    }



}



