package cn.ibizlab.businesscentral.core.odoo_base.service.impl;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import java.util.Set;
import java.util.Map;
import java.util.HashSet;
import java.util.HashMap;
import java.util.Collection;
import java.util.Objects;
import java.util.Optional;
import java.math.BigInteger;

import lombok.extern.slf4j.Slf4j;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.stereotype.Service;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.util.ObjectUtils;
import org.springframework.beans.factory.annotation.Value;
import cn.ibizlab.businesscentral.util.errors.BadRequestAlertException;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.context.annotation.Lazy;
import cn.ibizlab.businesscentral.core.odoo_base.domain.Base_module_upgrade;
import cn.ibizlab.businesscentral.core.odoo_base.filter.Base_module_upgradeSearchContext;
import cn.ibizlab.businesscentral.core.odoo_base.service.IBase_module_upgradeService;

import cn.ibizlab.businesscentral.util.helper.CachedBeanCopier;
import cn.ibizlab.businesscentral.util.helper.DEFieldCacheMap;


import cn.ibizlab.businesscentral.core.odoo_base.client.base_module_upgradeFeignClient;

/**
 * 实体[升级模块] 服务对象接口实现
 */
@Slf4j
@Service
public class Base_module_upgradeServiceImpl implements IBase_module_upgradeService {

    @Autowired
    base_module_upgradeFeignClient base_module_upgradeFeignClient;


    @Override
    public boolean create(Base_module_upgrade et) {
        Base_module_upgrade rt = base_module_upgradeFeignClient.create(et);
        if(rt==null)
            return false;
        CachedBeanCopier.copy(rt,et);
        return true;
    }

    public void createBatch(List<Base_module_upgrade> list){
        base_module_upgradeFeignClient.createBatch(list) ;
    }

    @Override
    public boolean update(Base_module_upgrade et) {
        Base_module_upgrade rt = base_module_upgradeFeignClient.update(et.getId(),et);
        if(rt==null)
            return false;
        CachedBeanCopier.copy(rt,et);
        return true;

    }

    public void updateBatch(List<Base_module_upgrade> list){
        base_module_upgradeFeignClient.updateBatch(list) ;
    }

    @Override
    public boolean remove(Long id) {
        boolean result=base_module_upgradeFeignClient.remove(id) ;
        return result;
    }

    public void removeBatch(Collection<Long> idList){
        base_module_upgradeFeignClient.removeBatch(idList);
    }

    @Override
    public Base_module_upgrade get(Long id) {
		Base_module_upgrade et=base_module_upgradeFeignClient.get(id);
        if(et==null){
            et=new Base_module_upgrade();
            et.setId(id);
        }
        else{
        }
        return  et;
    }





    /**
     * 查询集合 默认查询
     */
    @Override
    public Page<Base_module_upgrade> searchDefault(Base_module_upgradeSearchContext context) {
        Page<Base_module_upgrade> base_module_upgrades=base_module_upgradeFeignClient.search(context);
        return base_module_upgrades;
    }



}



