package cn.ibizlab.businesscentral.core.odoo_base_import.service.impl;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import java.util.Set;
import java.util.Map;
import java.util.HashSet;
import java.util.HashMap;
import java.util.Collection;
import java.util.Objects;
import java.util.Optional;
import java.math.BigInteger;

import lombok.extern.slf4j.Slf4j;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.stereotype.Service;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.util.ObjectUtils;
import org.springframework.beans.factory.annotation.Value;
import cn.ibizlab.businesscentral.util.errors.BadRequestAlertException;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.context.annotation.Lazy;
import cn.ibizlab.businesscentral.core.odoo_base_import.domain.Base_import_tests_models_complex;
import cn.ibizlab.businesscentral.core.odoo_base_import.filter.Base_import_tests_models_complexSearchContext;
import cn.ibizlab.businesscentral.core.odoo_base_import.service.IBase_import_tests_models_complexService;

import cn.ibizlab.businesscentral.util.helper.CachedBeanCopier;
import cn.ibizlab.businesscentral.util.helper.DEFieldCacheMap;


import cn.ibizlab.businesscentral.core.odoo_base_import.client.base_import_tests_models_complexFeignClient;

/**
 * 实体[测试:基本导入模型复合体] 服务对象接口实现
 */
@Slf4j
@Service
public class Base_import_tests_models_complexServiceImpl implements IBase_import_tests_models_complexService {

    @Autowired
    base_import_tests_models_complexFeignClient base_import_tests_models_complexFeignClient;


    @Override
    public boolean create(Base_import_tests_models_complex et) {
        Base_import_tests_models_complex rt = base_import_tests_models_complexFeignClient.create(et);
        if(rt==null)
            return false;
        CachedBeanCopier.copy(rt,et);
        return true;
    }

    public void createBatch(List<Base_import_tests_models_complex> list){
        base_import_tests_models_complexFeignClient.createBatch(list) ;
    }

    @Override
    public boolean update(Base_import_tests_models_complex et) {
        Base_import_tests_models_complex rt = base_import_tests_models_complexFeignClient.update(et.getId(),et);
        if(rt==null)
            return false;
        CachedBeanCopier.copy(rt,et);
        return true;

    }

    public void updateBatch(List<Base_import_tests_models_complex> list){
        base_import_tests_models_complexFeignClient.updateBatch(list) ;
    }

    @Override
    public boolean remove(Long id) {
        boolean result=base_import_tests_models_complexFeignClient.remove(id) ;
        return result;
    }

    public void removeBatch(Collection<Long> idList){
        base_import_tests_models_complexFeignClient.removeBatch(idList);
    }

    @Override
    public Base_import_tests_models_complex get(Long id) {
		Base_import_tests_models_complex et=base_import_tests_models_complexFeignClient.get(id);
        if(et==null){
            et=new Base_import_tests_models_complex();
            et.setId(id);
        }
        else{
        }
        return  et;
    }





    /**
     * 查询集合 默认查询
     */
    @Override
    public Page<Base_import_tests_models_complex> searchDefault(Base_import_tests_models_complexSearchContext context) {
        Page<Base_import_tests_models_complex> base_import_tests_models_complexs=base_import_tests_models_complexFeignClient.search(context);
        return base_import_tests_models_complexs;
    }



}



