package cn.ibizlab.businesscentral.core.odoo_crm.service.impl;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import java.util.Set;
import java.util.Map;
import java.util.HashSet;
import java.util.HashMap;
import java.util.Collection;
import java.util.Objects;
import java.util.Optional;
import java.math.BigInteger;

import lombok.extern.slf4j.Slf4j;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.stereotype.Service;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.util.ObjectUtils;
import org.springframework.beans.factory.annotation.Value;
import cn.ibizlab.businesscentral.util.errors.BadRequestAlertException;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.context.annotation.Lazy;
import cn.ibizlab.businesscentral.core.odoo_crm.domain.Crm_lead;
import cn.ibizlab.businesscentral.core.odoo_crm.filter.Crm_leadSearchContext;
import cn.ibizlab.businesscentral.core.odoo_crm.service.ICrm_leadService;

import cn.ibizlab.businesscentral.util.helper.CachedBeanCopier;
import cn.ibizlab.businesscentral.util.helper.DEFieldCacheMap;


import cn.ibizlab.businesscentral.core.odoo_crm.client.crm_leadFeignClient;

/**
 * 实体[线索/商机] 服务对象接口实现
 */
@Slf4j
@Service
public class Crm_leadServiceImpl implements ICrm_leadService {

    @Autowired
    crm_leadFeignClient crm_leadFeignClient;


    @Override
    public boolean create(Crm_lead et) {
        Crm_lead rt = crm_leadFeignClient.create(et);
        if(rt==null)
            return false;
        CachedBeanCopier.copy(rt,et);
        return true;
    }

    public void createBatch(List<Crm_lead> list){
        crm_leadFeignClient.createBatch(list) ;
    }

    @Override
    public boolean update(Crm_lead et) {
        Crm_lead rt = crm_leadFeignClient.update(et.getId(),et);
        if(rt==null)
            return false;
        CachedBeanCopier.copy(rt,et);
        return true;

    }

    public void updateBatch(List<Crm_lead> list){
        crm_leadFeignClient.updateBatch(list) ;
    }

    @Override
    public boolean remove(Long id) {
        boolean result=crm_leadFeignClient.remove(id) ;
        return result;
    }

    public void removeBatch(Collection<Long> idList){
        crm_leadFeignClient.removeBatch(idList);
    }

    @Override
    public Crm_lead get(Long id) {
		Crm_lead et=crm_leadFeignClient.get(id);
        if(et==null){
            et=new Crm_lead();
            et.setId(id);
        }
        else{
        }
        return  et;
    }





    /**
     * 查询集合 默认查询
     */
    @Override
    public Page<Crm_lead> searchDefault(Crm_leadSearchContext context) {
        Page<Crm_lead> crm_leads=crm_leadFeignClient.search(context);
        return crm_leads;
    }



}



