package cn.ibizlab.businesscentral.core.odoo_crm.service.impl;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import java.util.Set;
import java.util.Map;
import java.util.HashSet;
import java.util.HashMap;
import java.util.Collection;
import java.util.Objects;
import java.util.Optional;
import java.math.BigInteger;

import lombok.extern.slf4j.Slf4j;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.stereotype.Service;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.util.ObjectUtils;
import org.springframework.beans.factory.annotation.Value;
import cn.ibizlab.businesscentral.util.errors.BadRequestAlertException;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.context.annotation.Lazy;
import cn.ibizlab.businesscentral.core.odoo_crm.domain.Crm_team;
import cn.ibizlab.businesscentral.core.odoo_crm.filter.Crm_teamSearchContext;
import cn.ibizlab.businesscentral.core.odoo_crm.service.ICrm_teamService;

import cn.ibizlab.businesscentral.util.helper.CachedBeanCopier;
import cn.ibizlab.businesscentral.util.helper.DEFieldCacheMap;


import cn.ibizlab.businesscentral.core.odoo_crm.client.crm_teamFeignClient;

/**
 * 实体[销售渠道] 服务对象接口实现
 */
@Slf4j
@Service
public class Crm_teamServiceImpl implements ICrm_teamService {

    @Autowired
    crm_teamFeignClient crm_teamFeignClient;

    @Autowired
    @Lazy
    protected cn.ibizlab.businesscentral.core.odoo_base.service.IRes_usersService resUsersService;

    @Override
    public boolean create(Crm_team et) {
        Crm_team rt = crm_teamFeignClient.create(et);
        if(rt==null)
            return false;
        CachedBeanCopier.copy(rt,et);
        return true;
    }

    public void createBatch(List<Crm_team> list){
        crm_teamFeignClient.createBatch(list) ;
    }

    @Override
    public boolean update(Crm_team et) {
        Crm_team rt = crm_teamFeignClient.update(et.getId(),et);
        if(rt==null)
            return false;
        CachedBeanCopier.copy(rt,et);
        return true;

    }

    public void updateBatch(List<Crm_team> list){
        crm_teamFeignClient.updateBatch(list) ;
    }

    @Override
    public boolean remove(Long id) {
        boolean result=crm_teamFeignClient.remove(id) ;
        return result;
    }

    public void removeBatch(Collection<Long> idList){
        crm_teamFeignClient.removeBatch(idList);
    }

    @Override
    public Crm_team get(Long id) {
		Crm_team et=crm_teamFeignClient.get(id);
        if(et==null){
            et=new Crm_team();
            et.setId(id);
        }
        else{
        }
        return  et;
    }





    /**
     * 查询集合 默认查询
     */
    @Override
    public Page<Crm_team> searchDefault(Crm_teamSearchContext context) {
        Page<Crm_team> crm_teams=crm_teamFeignClient.search(context);
        return crm_teams;
    }



}



