package cn.ibizlab.businesscentral.core.odoo_event.service.impl;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import java.util.Set;
import java.util.Map;
import java.util.HashSet;
import java.util.HashMap;
import java.util.Collection;
import java.util.Objects;
import java.util.Optional;
import java.math.BigInteger;

import lombok.extern.slf4j.Slf4j;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.stereotype.Service;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.util.ObjectUtils;
import org.springframework.beans.factory.annotation.Value;
import cn.ibizlab.businesscentral.util.errors.BadRequestAlertException;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.context.annotation.Lazy;
import cn.ibizlab.businesscentral.core.odoo_event.domain.Event_event;
import cn.ibizlab.businesscentral.core.odoo_event.filter.Event_eventSearchContext;
import cn.ibizlab.businesscentral.core.odoo_event.service.IEvent_eventService;

import cn.ibizlab.businesscentral.util.helper.CachedBeanCopier;
import cn.ibizlab.businesscentral.util.helper.DEFieldCacheMap;


import cn.ibizlab.businesscentral.core.odoo_event.client.event_eventFeignClient;

/**
 * 实体[活动] 服务对象接口实现
 */
@Slf4j
@Service
public class Event_eventServiceImpl implements IEvent_eventService {

    @Autowired
    event_eventFeignClient event_eventFeignClient;


    @Override
    public boolean create(Event_event et) {
        Event_event rt = event_eventFeignClient.create(et);
        if(rt==null)
            return false;
        CachedBeanCopier.copy(rt,et);
        return true;
    }

    public void createBatch(List<Event_event> list){
        event_eventFeignClient.createBatch(list) ;
    }

    @Override
    public boolean update(Event_event et) {
        Event_event rt = event_eventFeignClient.update(et.getId(),et);
        if(rt==null)
            return false;
        CachedBeanCopier.copy(rt,et);
        return true;

    }

    public void updateBatch(List<Event_event> list){
        event_eventFeignClient.updateBatch(list) ;
    }

    @Override
    public boolean remove(Long id) {
        boolean result=event_eventFeignClient.remove(id) ;
        return result;
    }

    public void removeBatch(Collection<Long> idList){
        event_eventFeignClient.removeBatch(idList);
    }

    @Override
    public Event_event get(Long id) {
		Event_event et=event_eventFeignClient.get(id);
        if(et==null){
            et=new Event_event();
            et.setId(id);
        }
        else{
        }
        return  et;
    }





    /**
     * 查询集合 默认查询
     */
    @Override
    public Page<Event_event> searchDefault(Event_eventSearchContext context) {
        Page<Event_event> event_events=event_eventFeignClient.search(context);
        return event_events;
    }



}



