package cn.ibizlab.businesscentral.core.odoo_hr.service.impl;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import java.util.Set;
import java.util.Map;
import java.util.HashSet;
import java.util.HashMap;
import java.util.Collection;
import java.util.Objects;
import java.util.Optional;
import java.math.BigInteger;

import lombok.extern.slf4j.Slf4j;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.stereotype.Service;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.util.ObjectUtils;
import org.springframework.beans.factory.annotation.Value;
import cn.ibizlab.businesscentral.util.errors.BadRequestAlertException;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.context.annotation.Lazy;
import cn.ibizlab.businesscentral.core.odoo_hr.domain.Hr_expense;
import cn.ibizlab.businesscentral.core.odoo_hr.filter.Hr_expenseSearchContext;
import cn.ibizlab.businesscentral.core.odoo_hr.service.IHr_expenseService;

import cn.ibizlab.businesscentral.util.helper.CachedBeanCopier;
import cn.ibizlab.businesscentral.util.helper.DEFieldCacheMap;


import cn.ibizlab.businesscentral.core.odoo_hr.client.hr_expenseFeignClient;

/**
 * 实体[费用] 服务对象接口实现
 */
@Slf4j
@Service
public class Hr_expenseServiceImpl implements IHr_expenseService {

    @Autowired
    hr_expenseFeignClient hr_expenseFeignClient;


    @Override
    public boolean create(Hr_expense et) {
        Hr_expense rt = hr_expenseFeignClient.create(et);
        if(rt==null)
            return false;
        CachedBeanCopier.copy(rt,et);
        return true;
    }

    public void createBatch(List<Hr_expense> list){
        hr_expenseFeignClient.createBatch(list) ;
    }

    @Override
    public boolean update(Hr_expense et) {
        Hr_expense rt = hr_expenseFeignClient.update(et.getId(),et);
        if(rt==null)
            return false;
        CachedBeanCopier.copy(rt,et);
        return true;

    }

    public void updateBatch(List<Hr_expense> list){
        hr_expenseFeignClient.updateBatch(list) ;
    }

    @Override
    public boolean remove(Long id) {
        boolean result=hr_expenseFeignClient.remove(id) ;
        return result;
    }

    public void removeBatch(Collection<Long> idList){
        hr_expenseFeignClient.removeBatch(idList);
    }

    @Override
    public Hr_expense get(Long id) {
		Hr_expense et=hr_expenseFeignClient.get(id);
        if(et==null){
            et=new Hr_expense();
            et.setId(id);
        }
        else{
        }
        return  et;
    }





    /**
     * 查询集合 默认查询
     */
    @Override
    public Page<Hr_expense> searchDefault(Hr_expenseSearchContext context) {
        Page<Hr_expense> hr_expenses=hr_expenseFeignClient.search(context);
        return hr_expenses;
    }



}



