package cn.ibizlab.businesscentral.core.odoo_mail.domain;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.math.BigInteger;
import java.util.HashMap;
import java.math.BigDecimal;
import java.text.SimpleDateFormat;
import com.alibaba.fastjson.annotation.JSONField;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.util.ObjectUtils;
import org.springframework.util.DigestUtils;
import cn.ibizlab.businesscentral.util.domain.EntityBase;
import cn.ibizlab.businesscentral.util.annotation.DEField;
import cn.ibizlab.businesscentral.util.enums.DEPredefinedFieldType;
import cn.ibizlab.businesscentral.util.enums.DEFieldDefaultValueType;
import java.io.Serializable;
import lombok.*;
import org.springframework.data.annotation.Transient;
import cn.ibizlab.businesscentral.util.annotation.Audit;

import cn.ibizlab.businesscentral.util.domain.EntityClient;

/**
 * ServiceApi [消息通知] 对象
 */
@Data
public class Mail_notification extends EntityClient implements Serializable {

    /**
     * 最后修改日
     */
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "__last_update" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("__last_update")
    private Timestamp LastUpdate;

    /**
     * ID
     */
    @DEField(isKeyField=true)
    @JSONField(name = "id")
    @JsonProperty("id")
    private Long id;

    /**
     * 失败原因
     */
    @DEField(name = "failure_reason")
    @JSONField(name = "failure_reason")
    @JsonProperty("failure_reason")
    private String failureReason;

    /**
     * 以邮件发送
     */
    @DEField(name = "is_email")
    @JSONField(name = "is_email")
    @JsonProperty("is_email")
    private Integer isEmail;

    /**
     * 已读
     */
    @DEField(name = "is_read")
    @JSONField(name = "is_read")
    @JsonProperty("is_read")
    private Integer isRead;

    /**
     * EMail状态
     */
    @DEField(name = "email_status")
    @JSONField(name = "email_status")
    @JsonProperty("email_status")
    private String emailStatus;

    /**
     * 显示名称
     */
    @JSONField(name = "display_name")
    @JsonProperty("display_name")
    private String displayName;

    /**
     * 失败类型
     */
    @DEField(name = "failure_type")
    @JSONField(name = "failure_type")
    @JsonProperty("failure_type")
    private String failureType;

    /**
     * 需收件人
     */
    @JSONField(name = "res_partner_id_text")
    @JsonProperty("res_partner_id_text")
    private String resPartnerIdText;

    /**
     * 邮件
     */
    @DEField(name = "mail_id")
    @JSONField(name = "mail_id")
    @JsonProperty("mail_id")
    private Long mailId;

    /**
     * 消息
     */
    @DEField(name = "mail_message_id")
    @JSONField(name = "mail_message_id")
    @JsonProperty("mail_message_id")
    private Long mailMessageId;

    /**
     * 需收件人
     */
    @DEField(name = "res_partner_id")
    @JSONField(name = "res_partner_id")
    @JsonProperty("res_partner_id")
    private Long resPartnerId;


    /**
     * 
     */
    @JSONField(name = "odoomail")
    @JsonProperty("odoomail")
    private cn.ibizlab.businesscentral.core.odoo_mail.domain.Mail_mail odooMail;

    /**
     * 
     */
    @JSONField(name = "odoomailmessage")
    @JsonProperty("odoomailmessage")
    private cn.ibizlab.businesscentral.core.odoo_mail.domain.Mail_message odooMailMessage;

    /**
     * 
     */
    @JSONField(name = "odoorespartner")
    @JsonProperty("odoorespartner")
    private cn.ibizlab.businesscentral.core.odoo_base.domain.Res_partner odooResPartner;




    /**
     * 设置 [失败原因]
     */
    public void setFailureReason(String failureReason){
        this.failureReason = failureReason ;
        this.modify("failure_reason",failureReason);
    }

    /**
     * 设置 [以邮件发送]
     */
    public void setIsEmail(Integer isEmail){
        this.isEmail = isEmail ;
        this.modify("is_email",isEmail);
    }

    /**
     * 设置 [已读]
     */
    public void setIsRead(Integer isRead){
        this.isRead = isRead ;
        this.modify("is_read",isRead);
    }

    /**
     * 设置 [EMail状态]
     */
    public void setEmailStatus(String emailStatus){
        this.emailStatus = emailStatus ;
        this.modify("email_status",emailStatus);
    }

    /**
     * 设置 [失败类型]
     */
    public void setFailureType(String failureType){
        this.failureType = failureType ;
        this.modify("failure_type",failureType);
    }

    /**
     * 设置 [邮件]
     */
    public void setMailId(Long mailId){
        this.mailId = mailId ;
        this.modify("mail_id",mailId);
    }

    /**
     * 设置 [消息]
     */
    public void setMailMessageId(Long mailMessageId){
        this.mailMessageId = mailMessageId ;
        this.modify("mail_message_id",mailMessageId);
    }

    /**
     * 设置 [需收件人]
     */
    public void setResPartnerId(Long resPartnerId){
        this.resPartnerId = resPartnerId ;
        this.modify("res_partner_id",resPartnerId);
    }

    /**
     * 复制当前对象数据到目标对象(粘贴重置)
     * @param targetEntity 目标数据对象
     * @param bIncEmpty  是否包括空值
     * @param <T>
     * @return
     */
    @Override
    public <T> T copyTo(T targetEntity, boolean bIncEmpty) {
        this.reset("id");
        return super.copyTo(targetEntity,bIncEmpty);
    }
}


