package cn.ibizlab.businesscentral.core.odoo_mail.service.impl;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import java.util.Set;
import java.util.Map;
import java.util.HashSet;
import java.util.HashMap;
import java.util.Collection;
import java.util.Objects;
import java.util.Optional;
import java.math.BigInteger;

import lombok.extern.slf4j.Slf4j;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.stereotype.Service;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.util.ObjectUtils;
import org.springframework.beans.factory.annotation.Value;
import cn.ibizlab.businesscentral.util.errors.BadRequestAlertException;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.context.annotation.Lazy;
import cn.ibizlab.businesscentral.core.odoo_mail.domain.Mail_tracking_value;
import cn.ibizlab.businesscentral.core.odoo_mail.filter.Mail_tracking_valueSearchContext;
import cn.ibizlab.businesscentral.core.odoo_mail.service.IMail_tracking_valueService;

import cn.ibizlab.businesscentral.util.helper.CachedBeanCopier;
import cn.ibizlab.businesscentral.util.helper.DEFieldCacheMap;


import cn.ibizlab.businesscentral.core.odoo_mail.client.mail_tracking_valueFeignClient;

/**
 * 实体[邮件跟踪值] 服务对象接口实现
 */
@Slf4j
@Service
public class Mail_tracking_valueServiceImpl implements IMail_tracking_valueService {

    @Autowired
    mail_tracking_valueFeignClient mail_tracking_valueFeignClient;


    @Override
    public boolean create(Mail_tracking_value et) {
        Mail_tracking_value rt = mail_tracking_valueFeignClient.create(et);
        if(rt==null)
            return false;
        CachedBeanCopier.copy(rt,et);
        return true;
    }

    public void createBatch(List<Mail_tracking_value> list){
        mail_tracking_valueFeignClient.createBatch(list) ;
    }

    @Override
    public boolean update(Mail_tracking_value et) {
        Mail_tracking_value rt = mail_tracking_valueFeignClient.update(et.getId(),et);
        if(rt==null)
            return false;
        CachedBeanCopier.copy(rt,et);
        return true;

    }

    public void updateBatch(List<Mail_tracking_value> list){
        mail_tracking_valueFeignClient.updateBatch(list) ;
    }

    @Override
    public boolean remove(Long id) {
        boolean result=mail_tracking_valueFeignClient.remove(id) ;
        return result;
    }

    public void removeBatch(Collection<Long> idList){
        mail_tracking_valueFeignClient.removeBatch(idList);
    }

    @Override
    public Mail_tracking_value get(Long id) {
		Mail_tracking_value et=mail_tracking_valueFeignClient.get(id);
        if(et==null){
            et=new Mail_tracking_value();
            et.setId(id);
        }
        else{
        }
        return  et;
    }





    /**
     * 查询集合 默认查询
     */
    @Override
    public Page<Mail_tracking_value> searchDefault(Mail_tracking_valueSearchContext context) {
        Page<Mail_tracking_value> mail_tracking_values=mail_tracking_valueFeignClient.search(context);
        return mail_tracking_values;
    }



}



