package cn.ibizlab.businesscentral.core.odoo_maintenance.service.impl;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import java.util.Set;
import java.util.Map;
import java.util.HashSet;
import java.util.HashMap;
import java.util.Collection;
import java.util.Objects;
import java.util.Optional;
import java.math.BigInteger;

import lombok.extern.slf4j.Slf4j;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.stereotype.Service;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.util.ObjectUtils;
import org.springframework.beans.factory.annotation.Value;
import cn.ibizlab.businesscentral.util.errors.BadRequestAlertException;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.context.annotation.Lazy;
import cn.ibizlab.businesscentral.core.odoo_maintenance.domain.Maintenance_team;
import cn.ibizlab.businesscentral.core.odoo_maintenance.filter.Maintenance_teamSearchContext;
import cn.ibizlab.businesscentral.core.odoo_maintenance.service.IMaintenance_teamService;

import cn.ibizlab.businesscentral.util.helper.CachedBeanCopier;
import cn.ibizlab.businesscentral.util.helper.DEFieldCacheMap;


import cn.ibizlab.businesscentral.core.odoo_maintenance.client.maintenance_teamFeignClient;

/**
 * 实体[保养团队] 服务对象接口实现
 */
@Slf4j
@Service
public class Maintenance_teamServiceImpl implements IMaintenance_teamService {

    @Autowired
    maintenance_teamFeignClient maintenance_teamFeignClient;


    @Override
    public boolean create(Maintenance_team et) {
        Maintenance_team rt = maintenance_teamFeignClient.create(et);
        if(rt==null)
            return false;
        CachedBeanCopier.copy(rt,et);
        return true;
    }

    public void createBatch(List<Maintenance_team> list){
        maintenance_teamFeignClient.createBatch(list) ;
    }

    @Override
    public boolean update(Maintenance_team et) {
        Maintenance_team rt = maintenance_teamFeignClient.update(et.getId(),et);
        if(rt==null)
            return false;
        CachedBeanCopier.copy(rt,et);
        return true;

    }

    public void updateBatch(List<Maintenance_team> list){
        maintenance_teamFeignClient.updateBatch(list) ;
    }

    @Override
    public boolean remove(Long id) {
        boolean result=maintenance_teamFeignClient.remove(id) ;
        return result;
    }

    public void removeBatch(Collection<Long> idList){
        maintenance_teamFeignClient.removeBatch(idList);
    }

    @Override
    public Maintenance_team get(Long id) {
		Maintenance_team et=maintenance_teamFeignClient.get(id);
        if(et==null){
            et=new Maintenance_team();
            et.setId(id);
        }
        else{
        }
        return  et;
    }





    /**
     * 查询集合 默认查询
     */
    @Override
    public Page<Maintenance_team> searchDefault(Maintenance_teamSearchContext context) {
        Page<Maintenance_team> maintenance_teams=maintenance_teamFeignClient.search(context);
        return maintenance_teams;
    }



}



