package cn.ibizlab.businesscentral.core.odoo_portal.service.impl;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import java.util.Set;
import java.util.Map;
import java.util.HashSet;
import java.util.HashMap;
import java.util.Collection;
import java.util.Objects;
import java.util.Optional;
import java.math.BigInteger;

import lombok.extern.slf4j.Slf4j;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.stereotype.Service;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.util.ObjectUtils;
import org.springframework.beans.factory.annotation.Value;
import cn.ibizlab.businesscentral.util.errors.BadRequestAlertException;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.context.annotation.Lazy;
import cn.ibizlab.businesscentral.core.odoo_portal.domain.Portal_wizard;
import cn.ibizlab.businesscentral.core.odoo_portal.filter.Portal_wizardSearchContext;
import cn.ibizlab.businesscentral.core.odoo_portal.service.IPortal_wizardService;

import cn.ibizlab.businesscentral.util.helper.CachedBeanCopier;
import cn.ibizlab.businesscentral.util.helper.DEFieldCacheMap;


import cn.ibizlab.businesscentral.core.odoo_portal.client.portal_wizardFeignClient;

/**
 * 实体[授予门户访问] 服务对象接口实现
 */
@Slf4j
@Service
public class Portal_wizardServiceImpl implements IPortal_wizardService {

    @Autowired
    portal_wizardFeignClient portal_wizardFeignClient;


    @Override
    public boolean create(Portal_wizard et) {
        Portal_wizard rt = portal_wizardFeignClient.create(et);
        if(rt==null)
            return false;
        CachedBeanCopier.copy(rt,et);
        return true;
    }

    public void createBatch(List<Portal_wizard> list){
        portal_wizardFeignClient.createBatch(list) ;
    }

    @Override
    public boolean update(Portal_wizard et) {
        Portal_wizard rt = portal_wizardFeignClient.update(et.getId(),et);
        if(rt==null)
            return false;
        CachedBeanCopier.copy(rt,et);
        return true;

    }

    public void updateBatch(List<Portal_wizard> list){
        portal_wizardFeignClient.updateBatch(list) ;
    }

    @Override
    public boolean remove(Long id) {
        boolean result=portal_wizardFeignClient.remove(id) ;
        return result;
    }

    public void removeBatch(Collection<Long> idList){
        portal_wizardFeignClient.removeBatch(idList);
    }

    @Override
    public Portal_wizard get(Long id) {
		Portal_wizard et=portal_wizardFeignClient.get(id);
        if(et==null){
            et=new Portal_wizard();
            et.setId(id);
        }
        else{
        }
        return  et;
    }





    /**
     * 查询集合 默认查询
     */
    @Override
    public Page<Portal_wizard> searchDefault(Portal_wizardSearchContext context) {
        Page<Portal_wizard> portal_wizards=portal_wizardFeignClient.search(context);
        return portal_wizards;
    }



}



