package cn.ibizlab.businesscentral.core.odoo_product.service.impl;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import java.util.Set;
import java.util.Map;
import java.util.HashSet;
import java.util.HashMap;
import java.util.Collection;
import java.util.Objects;
import java.util.Optional;
import java.math.BigInteger;

import lombok.extern.slf4j.Slf4j;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.stereotype.Service;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.util.ObjectUtils;
import org.springframework.beans.factory.annotation.Value;
import cn.ibizlab.businesscentral.util.errors.BadRequestAlertException;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.context.annotation.Lazy;
import cn.ibizlab.businesscentral.core.odoo_product.domain.Product_packaging;
import cn.ibizlab.businesscentral.core.odoo_product.filter.Product_packagingSearchContext;
import cn.ibizlab.businesscentral.core.odoo_product.service.IProduct_packagingService;

import cn.ibizlab.businesscentral.util.helper.CachedBeanCopier;
import cn.ibizlab.businesscentral.util.helper.DEFieldCacheMap;


import cn.ibizlab.businesscentral.core.odoo_product.client.product_packagingFeignClient;

/**
 * 实体[产品包装] 服务对象接口实现
 */
@Slf4j
@Service
public class Product_packagingServiceImpl implements IProduct_packagingService {

    @Autowired
    product_packagingFeignClient product_packagingFeignClient;


    @Override
    public boolean create(Product_packaging et) {
        Product_packaging rt = product_packagingFeignClient.create(et);
        if(rt==null)
            return false;
        CachedBeanCopier.copy(rt,et);
        return true;
    }

    public void createBatch(List<Product_packaging> list){
        product_packagingFeignClient.createBatch(list) ;
    }

    @Override
    public boolean update(Product_packaging et) {
        Product_packaging rt = product_packagingFeignClient.update(et.getId(),et);
        if(rt==null)
            return false;
        CachedBeanCopier.copy(rt,et);
        return true;

    }

    public void updateBatch(List<Product_packaging> list){
        product_packagingFeignClient.updateBatch(list) ;
    }

    @Override
    public boolean remove(Long id) {
        boolean result=product_packagingFeignClient.remove(id) ;
        return result;
    }

    public void removeBatch(Collection<Long> idList){
        product_packagingFeignClient.removeBatch(idList);
    }

    @Override
    public Product_packaging get(Long id) {
		Product_packaging et=product_packagingFeignClient.get(id);
        if(et==null){
            et=new Product_packaging();
            et.setId(id);
        }
        else{
        }
        return  et;
    }





    /**
     * 查询集合 默认查询
     */
    @Override
    public Page<Product_packaging> searchDefault(Product_packagingSearchContext context) {
        Page<Product_packaging> product_packagings=product_packagingFeignClient.search(context);
        return product_packagings;
    }



}



