package cn.ibizlab.businesscentral.core.odoo_repair.service.impl;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import java.util.Set;
import java.util.Map;
import java.util.HashSet;
import java.util.HashMap;
import java.util.Collection;
import java.util.Objects;
import java.util.Optional;
import java.math.BigInteger;

import lombok.extern.slf4j.Slf4j;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.stereotype.Service;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.util.ObjectUtils;
import org.springframework.beans.factory.annotation.Value;
import cn.ibizlab.businesscentral.util.errors.BadRequestAlertException;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.context.annotation.Lazy;
import cn.ibizlab.businesscentral.core.odoo_repair.domain.Repair_fee;
import cn.ibizlab.businesscentral.core.odoo_repair.filter.Repair_feeSearchContext;
import cn.ibizlab.businesscentral.core.odoo_repair.service.IRepair_feeService;

import cn.ibizlab.businesscentral.util.helper.CachedBeanCopier;
import cn.ibizlab.businesscentral.util.helper.DEFieldCacheMap;


import cn.ibizlab.businesscentral.core.odoo_repair.client.repair_feeFeignClient;

/**
 * 实体[修理费] 服务对象接口实现
 */
@Slf4j
@Service
public class Repair_feeServiceImpl implements IRepair_feeService {

    @Autowired
    repair_feeFeignClient repair_feeFeignClient;


    @Override
    public boolean create(Repair_fee et) {
        Repair_fee rt = repair_feeFeignClient.create(et);
        if(rt==null)
            return false;
        CachedBeanCopier.copy(rt,et);
        return true;
    }

    public void createBatch(List<Repair_fee> list){
        repair_feeFeignClient.createBatch(list) ;
    }

    @Override
    public boolean update(Repair_fee et) {
        Repair_fee rt = repair_feeFeignClient.update(et.getId(),et);
        if(rt==null)
            return false;
        CachedBeanCopier.copy(rt,et);
        return true;

    }

    public void updateBatch(List<Repair_fee> list){
        repair_feeFeignClient.updateBatch(list) ;
    }

    @Override
    public boolean remove(Long id) {
        boolean result=repair_feeFeignClient.remove(id) ;
        return result;
    }

    public void removeBatch(Collection<Long> idList){
        repair_feeFeignClient.removeBatch(idList);
    }

    @Override
    public Repair_fee get(Long id) {
		Repair_fee et=repair_feeFeignClient.get(id);
        if(et==null){
            et=new Repair_fee();
            et.setId(id);
        }
        else{
        }
        return  et;
    }





    /**
     * 查询集合 默认查询
     */
    @Override
    public Page<Repair_fee> searchDefault(Repair_feeSearchContext context) {
        Page<Repair_fee> repair_fees=repair_feeFeignClient.search(context);
        return repair_fees;
    }



}



